package java.lang;

public final class Integer extends Number {
   public static final int MIN_VALUE = -2147483648;
   public static final int MAX_VALUE = 2147483647;
   public static final Class TYPE = Class.getPrimitiveClass("int");
   private int value;
   private static final long serialVersionUID = 1360826667806852920L;

   public static String toString(int var0, int var1) {
      if (var1 < 2 || var1 > 36) {
         var1 = 10;
      }

      StringBuffer var2 = new StringBuffer(var1 >= 8 ? 12 : 33);
      boolean var3 = var0 < 0;
      if (!var3) {
         var0 = -var0;
      }

      while(var0 <= -var1) {
         var2.append(Character.forDigit(-(var0 % var1), var1));
         var0 /= var1;
      }

      var2.append(Character.forDigit(-var0, var1));
      if (var3) {
         var2.append('-');
      }

      return var2.reverse().toString();
   }

   public static String toHexString(int var0) {
      return toUnsignedString(var0, 4);
   }

   public static String toOctalString(int var0) {
      return toUnsignedString(var0, 3);
   }

   public static String toBinaryString(int var0) {
      return toUnsignedString(var0, 1);
   }

   private static String toUnsignedString(int var0, int var1) {
      StringBuffer var2 = new StringBuffer(var1 >= 3 ? 11 : 32);
      int var3 = 1 << var1;
      int var4 = var3 - 1;

      do {
         var2.append(Character.forDigit(var0 & var4, var3));
         var0 >>>= var1;
      } while(var0 != 0);

      return var2.reverse().toString();
   }

   public static String toString(int var0) {
      return toString(var0, 10);
   }

   public static int parseInt(String var0, int var1) throws NumberFormatException {
      if (var0 == null) {
         throw new NumberFormatException("null");
      } else {
         int var2 = 0;
         boolean var3 = false;
         int var4 = 0;
         int var5 = var0.length();
         if (var5 <= 0) {
            throw new NumberFormatException(var0);
         } else {
            int var6;
            if (var0.charAt(0) == '-') {
               var3 = true;
               var6 = MIN_VALUE;
               ++var4;
            } else {
               var6 = -2147483647;
            }

            int var7 = var6 / var1;
            if (var4 < var5) {
               int var8 = Character.digit(var0.charAt(var4++), var1);
               if (var8 < 0) {
                  throw new NumberFormatException(var0);
               }

               var2 = -var8;
            }

            while(var4 < var5) {
               int var10 = Character.digit(var0.charAt(var4++), var1);
               if (var10 < 0) {
                  throw new NumberFormatException(var0);
               }

               if (var2 < var7) {
                  throw new NumberFormatException(var0);
               }

               var2 *= var1;
               if (var2 < var6 + var10) {
                  throw new NumberFormatException(var0);
               }

               var2 -= var10;
            }

            if (var3) {
               if (var4 > 1) {
                  return var2;
               } else {
                  throw new NumberFormatException(var0);
               }
            } else {
               return -var2;
            }
         }
      }
   }

   public static int parseInt(String var0) throws NumberFormatException {
      return parseInt(var0, 10);
   }

   public static Integer valueOf(String var0, int var1) throws NumberFormatException {
      return new Integer(parseInt(var0, var1));
   }

   public static Integer valueOf(String var0) throws NumberFormatException {
      return new Integer(parseInt(var0, 10));
   }

   public Integer(int var1) {
      this.value = var1;
   }

   public Integer(String var1) throws NumberFormatException {
      this.value = parseInt(var1, 10);
   }

   public byte byteValue() {
      return (byte)this.value;
   }

   public short shortValue() {
      return (short)this.value;
   }

   public int intValue() {
      return this.value;
   }

   public long longValue() {
      return (long)this.value;
   }

   public float floatValue() {
      return (float)this.value;
   }

   public double doubleValue() {
      return (double)this.value;
   }

   public String toString() {
      return String.valueOf(this.value);
   }

   public int hashCode() {
      return this.value;
   }

   public boolean equals(Object var1) {
      if (var1 != null && var1 instanceof Integer) {
         return this.value == (Integer)var1;
      } else {
         return false;
      }
   }

   public static Integer getInteger(String var0) {
      return getInteger(var0, (Integer)null);
   }

   public static Integer getInteger(String var0, int var1) {
      Integer var2 = getInteger(var0, (Integer)null);
      return var2 == null ? new Integer(var1) : var2;
   }

   public static Integer getInteger(String var0, Integer var1) {
      SecurityManager.enablePrivilege("UniversalPropertyRead");
      String var2 = System.getProperty(var0);
      if (var2 != null) {
         try {
            return decode(var2);
         } catch (NumberFormatException var3) {
         }
      }

      return var1;
   }

   public static Integer decode(String var0) throws NumberFormatException {
      if (var0.startsWith("0x")) {
         return valueOf(var0.substring(2), 16);
      } else if (var0.startsWith("#")) {
         return valueOf(var0.substring(1), 16);
      } else {
         return var0.startsWith("0") && var0.length() > 1 ? valueOf(var0.substring(1), 8) : valueOf(var0);
      }
   }
}
